/* codeconv.c			by Denes Tarjan (c) 1993-2004	*/
/* This program converts the textfile's hungarian characters	*/
/* between different code conventions.				*/

#define Version "2.3"
/* new in 2.1.0 : fixed bug when filenames such as a:foo.bar used
   new in 2.2.0 : long filename handling in Win9x systems
   new in 2.3   : small improvement in searching, new UTF-8-Latin1 table
*/
#define LastUpd "2004.05.27."

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <ctype.h>
#include "codeconv.h"
#include "w95lfn.h"

nev	tabneve;						/* filename for the tabfile */
char	intype[MaxCodeNameLen],
		outtype[MaxCodeNameLen];	/* ki-,bemeneti tipusnev roviditve*/
byte	**outcod;					/* mutato a ki-kodok tablazatara */
int		onmaga,						/* A file-t ua. neven mentsuk-e el*/
		futinfkiir,					/* Kiirjunk-e uzeneteket */
		csakkeres,			/* Csak megkeressuk, milyen kodolast hasznal */
		nemetkodok,			/* german characters also count */
		mprogram[MaxProgLine][2],
		MProgSize,
		maxcodlen,
		listazas,
		ret_value=0,
		copymarki=0,
		codn=0;						/* kodkonvenciok szama */
int		win95;						/* win95 alol inditottak-e */
char 	*cname[MaxCodeSetNum],		/* kodkonvenciok nevei, */
		*cabbr[MaxCodeSetNum];		/*			roviditesei */
int		help=FALSE;
/*-------------------Search for whitespace in string----------------------*/
char *strwsp(char *s)
{
	char *t;
	for (t=s;(!iswspace(*t))&&(*t!='\0');t++)
		;
	if (*t=='\0')
		return 0;
	else
		return t;
}
/*---------------------Delete string's first character--------------------*/
char *strdel1(char *s)
{
	char *t;
	for (t=s;((*t=*(t+1))!='\0');t++)
		;
	return s;
}
/*---------------------Convert string to uppercase------------------------*/
char *strupr(char *s)
{
	char *t;
	for (t=s;*t!='\0';t++)
		if ((*t>='a')&&(*t<='z'))
			*t=*t+'A'-'a';
	return s;
}
/*--------------------Ha van win95, igy kell megnyitni--------------------*/
FILE *ccfopen(char *fname, char *mode)
{
	int access = 0, handle;
#ifdef __MSDOS__
	if (win95)
	{
		if (strchr(mode,'+') != NULL)
			access = O_RDWR;
		else if (strchr(mode,'r') != NULL)
			access = O_RDONLY;
		else access = O_WRONLY;
/*		if (strchr(mode,'w') != NULL)
			access |= O_TRUNC; */
		if (strchr(mode,'a') != NULL)
			access |= O_APPEND;
		if ((strchr(mode,'a') != NULL) || (strchr(mode,'w') != NULL))
			access |= O_CREAT;
		handle = w95open(fname, access);
		if (handle < 0)
			return NULL;
		return (FILE*)fdopen(handle, mode);
	}else
#endif
		return fopen(fname, mode);
}
/*---------------------Hasznalati utasitas kiirasa-------------------------*/
void Copyright(void)
{
	if (!copymarki)
	{
		copymarki=1;
		fprintf(stderr,"codeconv v%s, %s  (c) Denes Tarjan\n",Version,LastUpd);
	}
}
void Usage(void)
{
	Copyright();
	fputs("Usage:\n",stderr);
	fputs("codeconv [infile] [outfile] -i<incode> -o<outcode> ",stderr);
	fputs("[-t<tabfile>] [-v] [-s] [-g]\n",stderr);
	fputs("  or\ncodeconv -l [-t<tabfile>]\n  or\ncodeconv -h\n",stderr);
	fputs("   * If outputfile is not specified, the result is saved to ",stderr);
	fputs("the inputfile;\n     the original file is given a 'bak' extension.\n",stderr);
	fputs("   * If inputfile is not specified, codeconv uses ",stderr);
	fputs("standard input/output.\n",stderr);
	fputs("     In this case specifying code systems is required.\n",stderr);
	fputs("     (Otherwise this will be done through keyboard, if not specifed.)\n",stderr);
	fputs("-i- tells the program to scan the ",stderr);
	fputs("inputfile to determine its type.\n",stderr);
	fputs("-t : use <tabfile> instead of 'codeconv.tab' to read ",stderr);
	fputs("the codes from\n     ('tab' extension is assumed).\n",stderr);
	fputs("-v : give verbose information about the process.\n",stderr);
	fputs("-s : just scan the file to ",stderr);
	fputs("determine its type, don't make conversion.\n",stderr);
	fputs("-l : list the code systems contained in the table file\n",stderr);
	fputs("     (not combined with other options except -t, see above).\n",stderr);
	fputs("-g : convert (or count) german characters also\n",stderr);
	fputs("-h : give this help text.\n",stderr);
}

/*----------------------Parametervizsgalat--------------------------------*/
void Opc(char *par, char *intype, char *outtype)
{
	if (par[1]=='i')			/* intype abbrev */
		strcpy(intype,par+2);		/* begins after -i */
	else if (par[1]=='o')			/* outtype abbrev */
		strcpy(outtype,par+2);
	else if (par[1]=='v')			/* verbose info */
		futinfkiir=TRUE;
	else if (par[1]=='s')
		csakkeres=TRUE;
	else if (par[1]=='t')
		strcpy(tabneve,par+2);		/* table file specified */
	else if (par[1]=='l')
		listazas=TRUE;
	else if (par[1]=='h')
		help=TRUE;
	else if (par[1]=='g')			/* german char codes */
		nemetkodok=TRUE;
	else
		{ Usage(); exit(252);}
}
/*-------------------Rename if one file name was given--------------------*/
void AtNevez(char *oldname, char *name)
{
	nev newname;
	char *s;

	strcpy(newname,name);
#ifdef __MSDOS__
	if (!win95)
	{
		if (strstr(newname,".bak"))		/* if it was .bak before */
		{
			if ((s=strchr(newname,'.'))!=NULL)
				*s='\0';
			strcat(newname,".~ba");		/* then it will be .~ba */
		}
		else
		{
			if ((s=strchr(newname,'.'))!=NULL)
				*s='\0';
			strcat(newname,".bak");		/* otherwise .bak */
		}
	} else strcat(newname,".bak");
#else
	strcat(newname,".bak");		/* give it a .bak */
#endif

#ifdef __MSDOS__
	if (win95) {
		w95delete(newname);
		w95move(name,newname);
		w95move(oldname,name);
	}
	else 
#endif
	{
		unlink(newname);
		rename(name,newname);
		rename(oldname,name);
	}
}

/*---------- Milyen kodkonvenciok vannak a tablazatban? ----------------*/
void Listazas(void)
{
	int	i,j,k,maxnamelen=0;
	char format[31];

	Copyright();
	fputs("Code systems in the table:\n\n",stderr);
	for (i=0;i<codn;i++)
		if (strlen(cname[i])>maxnamelen)
			maxnamelen=strlen(cname[i]);
	sprintf(format,"%%-%ds %%-%ds ",maxnamelen+2,35-maxnamelen);
	fprintf(stderr,format,"Name","Abbreviation");
	fprintf(stderr,format,"Name","Abbreviation");
	putchar('\n');
	fputs("----------------------------------------",stderr);
	fputs("---------------------------------------\n",stderr);
	k=(codn+1)/2;
	for (i=0;i<k;i++)
	{
		for (j=0;j<2;j++)
			if (j*k+i<codn)
				fprintf(stderr,format,cname[i+j*k],cabbr[i+j*k]);
		putchar('\n');
	}
	fputs("\nUse -i- for automatic detection.\n",stderr);
	fprintf(stderr,
		"There is room in the table for another %d code systems.\n",
		MaxCodeSetNum-codn);
}



/* ============================= Foprogram ============================ */

int main(int argc, char *argv[])
{

int i;						/* ciklusvaltozok*/
nev befn,kifn,				/* be-,kimeneti fileok utvonallal */
	par,					/* parameter beolvasasara */
	prg_ut,					/* inditasi utvonal */
	env_str;				/* environment string */
char *sp;					/* string pointer for anything */

befn[0]='\0';		kifn[0]='\0';			tabneve[0]='\0';
onmaga=FALSE;		csakkeres=FALSE;		futinfkiir=FALSE;
intype[0]='\0';		outtype[0]='\0';		listazas=FALSE;
nemetkodok=FALSE;

#ifdef __MSDOS__
if (w95open("dummy176.$$$",O_RDONLY) != -2)		/* -2 : not supported */
	win95 = TRUE;
#endif

strcpy(prg_ut,argv[0]);
/*fprintf(stderr,"argv[0]: %s\n",prg_ut);*/
sp=strchr(prg_ut,'\0')-1;
while ((*sp!=LDir)&&(sp>=prg_ut))
	sp--;
*(sp+1)='\0';						/* now prg_ut is the program's path */
/*fprintf(stderr,"Utvonal: %s\n",prg_ut);*/

/* get the environment for "codeconv"*/
#ifdef __MSDOS__
if ((sp=getenv("CODECONV"))!=NULL)
#else
if ((sp=getenv("codeconv"))!=NULL)
#endif
{
	strcpy(env_str,sp);
	sp=strchr(env_str,'\0');
	if (*(sp-1)!=LDir)
	{
		sp[0]=LDir;
		sp[1]='\0';
	}
}
else
	strcpy(env_str,"");
/*---------------------------Parametervizsgalat----------------------------*/
if (argc>1)				/* ha van parameter*/
{
	for (i=1;i<argc;i++)
	{
		strcpy(par,argv[i]);
		if ((par[0]=='-')
#ifdef __MSDOS__
			||(par[0]=='/')
#endif
			)
			Opc(par,intype,outtype);		/*ha opcio*/
		else if (befn[0]=='\0')
			strcpy(befn,par);
		else if (kifn[0]=='\0')
			strcpy(kifn,par);
	}
}
if (help)
	{ Usage();	exit(254);	}
if (tabneve[0]=='\0')
	strcpy(tabneve,"codeconv.tab");
if (strchr(tabneve,'.')==NULL)
	strcat(tabneve,".tab");		/* alapertelmezett a .tab kiterjesztes */
if (futinfkiir)
	fprintf(stderr,"Table: %s\n",tabneve);
/*------------------------Betoltjuk a neveket, roviditeseket-------------*/
cname[0]=(char*)malloc(MaxCodeSetNum*MaxCodeNameLen*sizeof(char));
cabbr[0]=(char*)malloc(MaxCodeSetNum*MaxCodeNameLen*sizeof(char));
if ((cname[0]==NULL)||(cabbr[0]==NULL))
	exit(251);				/* Nincs eleg mem. */
LoadNames(env_str,prg_ut,tabneve,cname,cabbr,&codn);

/*-----------------------Minden adatot megkaptunk,dolgozhatunk-----------*/
if (listazas)
	{	Listazas();	exit(0);	}
/*if (befn[0]=='\0')
	{	Usage();	exit(254);}*/
if (kifn[0]=='\0')
	strcpy(kifn,befn);
/* Kezimegadas, csak ha nem kereses modban vagyunk
   es nem stdinrol olvasunk */
if (!csakkeres&&((intype[0]=='\0')||(outtype[0]=='\0'))&&(befn[0]!='\0'))
	Kezimegadas(intype,outtype);
if (!strcmp(befn,kifn) && (befn[0]!='\0'))	/*ugyanaz, de nem stdin*/
{
	onmaga=TRUE;
	sp=strchr(kifn,'\0')-1;
	while ((*sp!=LDir) && (sp>=kifn)
#ifdef __MSDOS__
		&& (*sp!=':')
#endif
		)
		sp--;
	*(sp+1)='\0';				/* now kifn has only its path */
	strcat(kifn,"codeconv.$$$");	/* kifn will be created at befn's path */
}
if (!csakkeres)
{
	if (futinfkiir)
	{
		Copyright();
		fprintf(stderr,"Compiling table...");
	}
	MakeProg(intype,outtype,&outcod,env_str,prg_ut,tabneve,befn);
/*	fprintf(stderr," Table compiled.\n");*/
	Konvertal(befn,kifn,outcod);
/*	fprintf(stderr,"Conversion done!\n");*/
	if (onmaga)
		AtNevez(kifn,befn);
	free((char*)outcod[0]);
	free((char*)outcod);
}
else
{
	if (futinfkiir)
		Copyright();
	ret_value=Keresd(env_str,prg_ut,tabneve,befn);
	fprintf(stderr,"Coding of %s is \'%s\'\n",befn,cname[ret_value]);
}
free((char*)cname[0]);
free((char*)cabbr[0]);
return (ret_value);
}
