#include <string.h>
#include <stdlib.h>
#include "codeconv.h"
#include "w95lfn.h"

static char *Puff_in = NULL;			/* input puffer */
static int pufftele = 0;				/* and its index */
static FILE *infile = NULL;
static FILE *outfile = NULL;

PufferIr(char *puffer,int *pop)
{
	int i;

	i=fwrite(puffer,sizeof(char),*pop,outfile);
	*pop=0;
	return i;
}
PufferOlv(char *puffer, int *pip, int *pwp, int *pep)
{
	int i;
	int readed;

	for (i=0;i<*pip-*pwp;i++)
		puffer[i]=puffer[i+*pwp];
	readed=fread(puffer+i,sizeof(char),PufferLen-i,infile);
/*	printf("Readed %d bytes. pwp=%d\n",readed,*pwp);*/
	*pip=i+readed;
	*pep-=*pwp;
	*pwp=0;
	return readed;
}
#define SEEK_SET 0
#define SEEK_END 2
long filesize(FILE *stream)
{
   long curpos, length;

   curpos = ftell(stream);
   fseek(stream, 0L, SEEK_END);
   length = ftell(stream);
   fseek(stream, curpos, SEEK_SET);
   return length;
}
Konvertal(char *befnev, char *kifnev, byte **outcod)
{
	char *Puff_out;	/* pufferek a be-, kivitelhez */
	int pip,			/* mutato'k:	a beolvasott adat vegere,*/
		pwp,					/*		a feldolgozott resz elejere,*/
		pep,					/*		a vizsgalat alatt levo reszre */
		pop,					/*		a kiirando adatok vegere */
		prcount;		/* program counter */
	long infpos=0,infsize=0;			/* file pozicioja, merete */

	if (futinfkiir)
		fprintf(stderr,"Converting %s (%s) to %s (%s) ...   ",
			befnev,intype,onmaga?befnev:kifnev,outtype);
	if (befnev[0]=='\0')
		infile=stdin;
	else if (infile==NULL)
	{
		if ((infile=ccfopen(befnev,"rt"))==NULL)
		{
			fprintf(stderr,"\nError reading %s file.\n",befnev);
			exit(2);
		}
	}
	if (kifnev[0]=='\0')
		outfile=stdout;
	else
	{
		if ((outfile=ccfopen(kifnev,"rt"))!=NULL)		/* already exists */
		{
			char bakname[PathLen];
			int i;
			strcpy(bakname,kifnev);
			for (i=strlen(bakname)-1;i--;(i>=0)&&(bakname[i]!='.'))
				;
			if (bakname[i]=='.')
				bakname[i]='\0';	/* truncate filename at last '.' */
			strcat(bakname,".bak");
#ifdef __MSDOS__
			if (win95)
				w95delete(bakname);
			else
#endif
				unlink(bakname);		/* be sure to delete if already exists*/
			fclose(outfile);
#ifdef __MSDOS__
			if (win95)
				w95move(kifnev,bakname);
			else
#endif
				rename(kifnev,bakname);
		}
		if ((outfile=ccfopen(kifnev,"wt"))==NULL)
		{
			fprintf(stderr,"\nError creating %s file.\n",kifnev);
			exit(3);
		}
	}
	infsize=filesize(infile);
	if (Puff_in==NULL)
	{
		Puff_in=(char*)malloc(PufferLen*sizeof(char));
		if (Puff_in==NULL)
		{
			fprintf(stderr,"Error: not enough memory\n");
			exit(4);
		}
	}
	Puff_out=(char*)malloc(PufferLen*sizeof(char));
	if (Puff_out==NULL)
	{
		fprintf(stderr,"\nError: not enough memory!\n");
		exit(4);
	}
	pop=0;
	if (pufftele)
		pip=pufftele;
	else
		pip=pufftele=fread(Puff_in,sizeof(char),PufferLen,infile);
	infpos=pip;
	pwp=pep=0;
	prcount=(byte)Puff_in[pep];
	do{
/*		printf("- %4d.line: %4d, %4d    | pwp=%d, pep=%d  %c\n",prcount,
			mprogram[prcount][0],mprogram[prcount][1],pwp,pep,
			Puff_in[pep]);*/
		switch (mprogram[prcount][0]>>8)
		{
			case NemTalalt:
					if (pop>=PufferLen-1)
						PufferIr(Puff_out,&pop);
					Puff_out[pop++]=Puff_in[pwp];
					prcount=0xFF & (byte)Puff_in[pep=++pwp];
					break;
			case CompGoto:
					if ((byte)Puff_in[pep]==(mprogram[prcount][0]&0xFF))
					{
						prcount=mprogram[prcount][1];
						pep++;
					}
					else
						prcount++;
					break;
			case CompReplace:
					if ((byte)Puff_in[pep]==(mprogram[prcount][0]&0xFF))
					{
						strcpy(Puff_out+pop,(char*)outcod[mprogram[prcount][1]]);
						pop+=strlen(Puff_out+pop);
						prcount=0xFF & (byte)Puff_in[pwp=++pep];
					}
					else
						prcount++;
					break;
			case DoGoto:
					prcount=mprogram[prcount][1];
					pep++;
					break;
			case DoReplace:
					if (pop+maxcodlen>=PufferLen-1)
						PufferIr(Puff_out,&pop);
					strcpy(Puff_out+pop,(char*)outcod[mprogram[prcount][1]]);
					pop+=strlen(Puff_out+pop);
					prcount=0xFF & (byte)Puff_in[pwp=pep];
/*					printf(" (replaced) char=%d %c prcount=%d\n",
						Puff_in[pwp],Puff_in[pwp],prcount);*/
					break;
		}
/*		printf("  %4d.line: %4d, %4d    | pwp=%d, pep=%d  %c\n",prcount,
			mprogram[prcount][0],mprogram[prcount][1],pwp,pep,
			Puff_in[pep]);*/
		if (pwp>=pip-maxcodlen-1)
		{
			if (futinfkiir)
				fprintf(stderr,"%3d %%\b\b\b\b\b",100*infpos/infsize);
			if (!feof(infile))
			{
				infpos+=PufferOlv(Puff_in,&pip,&pwp,&pep);
				pufftele=pip;
			}
		}
	}while (!feof(infile)||(pwp!=pip));
	PufferIr(Puff_out,&pop);
	fclose(infile),fclose(outfile);
	free(Puff_in),free(Puff_out);
	if (futinfkiir)
		fprintf(stderr,"done.\n");
	return 0;
}

int Keresd(char *utvonal1, char *utvonal2, char *tabneve, char *befnev)
{
	int pip,			/* mutato'k:	a beolvasott adat vegere,*/
		pwp,					/*		a feldolgozott resz elejere,*/
		pep;					/*		a vizsgalat alatt levo reszre */
	unsigned int prcount;		/* program counter */
	long found[MaxCodeSetNum];
		/* a fileban elofordulo kodok szamlaloja */
	int	i,k,
		maxnc,
		codsn;			/* codesetnum. */
	int	maxnamelen=0;
	char format[31],format2[31],format_aei[31],format2_aei[31];
	long infpos,infsize;			/* file pozicioja, merete */

/*	fputs("mksearch elott...",stderr);*/
	MakeSearchProg(utvonal1,utvonal2,tabneve,&codsn);
/*	fputs("mksearch utan...",stderr);*/
	if (futinfkiir)
		fprintf(stderr,"Scanning %s... ",befnev);
	if (befnev[0]=='\0')
		infile=stdin;
	else if ((infile=ccfopen(befnev,"r"))==NULL)
	{
		fprintf(stderr,"\nError: Can\'t open %s file.\n",befnev);
		exit(2);
	}
	for (i=0;i<codsn;i++)
		found[i]=0;
	if (Puff_in==NULL)
	{
		Puff_in=(char*)malloc(PufferLen*sizeof(char));
		if (Puff_in==NULL)
		{
			fprintf(stderr,"Error: not enough memory\n");
			exit(4);
		}
	}
/*	infsize=filesize(infile);*/
	pip=(pufftele=fread(Puff_in,sizeof(char),PufferLen,infile));
/*	infpos=pip;*/
	pep=pwp=0;
	prcount=(byte)Puff_in[pep];
	if (futinfkiir)
		fputs("keresem...\n",stderr);
	do{
/*		if (futinfkiir)
			printf("| %d (%d) ",prcount,Puff_in[pep]);*/
		switch (mprogram[prcount][0]>>8)
		{
			case NemTalalt:
					prcount=0xFF & (byte)Puff_in[pep=++pwp];
/*					printf("%u:%u,%u %u,%u:%u ; ",prcount,
				mprogram[prcount][0],mprogram[prcount][1],
				pwp,prcount,mprogram[prcount][0]);
					prcount=0xFF & (byte)Puff_in[pep=++pwp];*/
					break;
			case CompGoto:
					if ((byte)Puff_in[pep]==(mprogram[prcount][0]&0xFF))
					{
						prcount=mprogram[prcount][1];
						pep++;
					}
					else
						prcount++;
					break;
			case CompReplace:
					if ((byte)Puff_in[pep]==(mprogram[prcount][0]&0xFF))
						found[mprogram[prcount][1]] += (pep - pwp + 1);
					prcount++;
					break;
			case DoGoto:
					prcount=mprogram[prcount][1];
					pep++;
					break;
			case DoReplace:
					found[mprogram[prcount][1]] += (pep - pwp);
					prcount++;
					break;
		}
/*		if (pwp>=pip-maxcodlen-1)
		{
			if (futinfkiir)
				fprintf(stderr,"%3d %%\b\b\b\b\b",100*infpos/infsize);
			infpos+=PufferOlv(infile,Puff_in,&pip,&pwp,&pep);
		}*/
	}while (/*!feof(infile)||*/(pwp!=pip));
/*	fclose(infile);*/
/*	fputs("megkerestem.\n",stderr);*/
	if (futinfkiir)
		fprintf(stderr,"done.\n");
	maxnc=0;
	for (i=0;i<codsn;i++)
		if (strlen(cname[i])>maxnamelen)
			maxnamelen=strlen(cname[i]);
	sprintf(format,"%%-%ds %%-%dld ",maxnamelen+2,34-maxnamelen);
	sprintf(format_aei,"(%%-%ds %%-%dld) ",maxnamelen+1,33-maxnamelen);
	sprintf(format2,"%%-%ds %%ld",maxnamelen+2);
	sprintf(format2_aei,"(%%-%ds %%ld)",maxnamelen+1);
	k=(codsn+1)/2;
	for (i=0;i<k;i++)
	{
		if (strcmp(cabbr[i],"aei")!=0)
		{
			if (futinfkiir)
				fprintf(stderr,format,cname[i],found[i]);
			if (found[i]>found[maxnc])
				maxnc=i;			/* bemeneti tipus */
		}
		else
			if (futinfkiir)
				fprintf(stderr,format_aei,cname[i],found[i]);
		if (k+i<codsn)
			if (strcmp(cabbr[k+i],"aei")!=0)
			{
				if (futinfkiir)
					fprintf(stderr,format2,cname[k+i],found[k+i]);
				if (found[k+i]>found[maxnc])
					maxnc=k+i;		/* bemeneti tipus */
			}
			else
				if (futinfkiir)
					fprintf(stderr,format2_aei,cname[k+i],found[k+i]);
		if (futinfkiir)
			fputc('\n',stderr);
	}
	if (csakkeres)
		free((char*)Puff_in);
	return maxnc;
}
