#include <stdlib.h>
#include <string.h>
#include "codeconv.h"
#include "w95lfn.h"

#define NOTYPE 255

void myerror(char *msg, int errorcode)
{
	fputs(msg,stderr);
	exit(errorcode);
}

char *myfgets(char *buffer, int n, FILE *f)
{
	int i;
	do{
		if (fgets(buffer,n,f)==NULL)
			return NULL;
		i = strlen(buffer) - 1;
		if (i >= 0)
			while ((buffer[i] == '\n')||(buffer[i] == '\r'))
				buffer[i--] = '\0';
	}while (buffer[0]==CommentChar);
/*	fprintf(stderr,"---%s\n",buffer);*/
	return buffer;
}

LoadCodes(char *intype, char *outtype, char *ut, char *ut2, char *tabfnev,
			char *befnev,
			byte ***incod, byte ***outcod,
			int  *cod_n)
{
	FILE *f;
	nev utvonal;
	byte s[2*MaxLineLen],s1[MaxLineLen],t[MaxLineLen],*st,*sc,c;
	int i,jin,jout,tin,tout,n,tie,tiv,toe,tov,resin,resout;
	int j,k;

	tin=tout=NOTYPE;
	if (!strcmp(intype,"-"))
	{
		if (futinfkiir)
			fputs("keresd elott...",stderr);
		tin=Keresd(ut,ut2,tabfnev,befnev);
		if (futinfkiir)
			fputs("keresd utan...",stderr);
	}
	strcpy(utvonal,ut);
	if ((f=ccfopen(tabfnev,"r"))==NULL)
		if ((f=ccfopen(strcat(utvonal,tabfnev),"r"))==NULL)
			{
			strcpy(utvonal,ut2);
			if ((f=ccfopen(strcat(utvonal,tabfnev),"r"))==NULL)
				{
				fprintf(stderr,"Table file '%s' does not exist\n",tabneve);
				fputs("or environment variable 'codeconv' not set.\n",stderr);
				exit(1);
				}
			}
	if (myfgets(s,MaxLineLen,f)==NULL)
		myerror("Error in the table\n",3);
	if (myfgets(s1,MaxLineLen,f)==NULL)
		myerror("Error in the table\n",3);
	while (iswspace(s1[0]))		/* names continuing in the next line */
	{
		strcat(s,s1);
		if (myfgets(s1,MaxLineLen,f)==NULL)
			myerror("Error in the table\n",3);
	}
/* Now we have the names, but we need the abbrevs */
	strcpy(s,s1);
	if (myfgets(s1,MaxLineLen,f)==NULL)
		myerror("Error in the table\n",3);
	while (iswspace(s1[0]))		/* abbrevs continuing in the next line */
	{
		strcat(s,s1);
		if (myfgets(s1,MaxLineLen,f)==NULL)
			myerror("Error in the table\n",3);
	}
	strcat(s," ");			/* to be sure */
	st=s;			n=0;
	strupr(intype);	strupr(outtype);
	do{
		while (iswspace(*st))
			st++;
		sc=strwsp(st);
		if (sc==NULL)
			break;
		strncpy(t,st,sc-st);
		t[sc-st]='\0';
		strupr(t);
/*		fprintf(stderr,"t=\"%s\", intype=\"%s\", outtype=\"%s\"\n",
			t,intype,outtype);*/
		if ((!strcmp(t,intype))&&(tin==NOTYPE))
			tin=n;
		if ((!strcmp(t,outtype))&&(tout==NOTYPE))
			tout=n;
		st=strwsp(st);
		n++;
	}while ((*st!='\0')&&((tin==NOTYPE)||(tout==NOTYPE)));
		/* megvannak a tipus-sorszamok*/
	if ((tin==NOTYPE)||(tout==NOTYPE))
	{
		fputs("Code is invalid or missing! 'codeconv -l' gives a list,\n",stderr);
		fputs("'codeconv -h' gives help.\n",stderr);
		exit(255);
	}
	if (!strcmp(intype,"-"))
		fprintf(stderr,"Code conventions: %s --> %s\n",
			cname[tin],cname[tout]);
	if (tin==tout)
		fputs("!! Code conventions for in and ",stderr),
		fputs("outfile are the same !!\n",stderr);

/***************** finished with the abbrevs, now go to the codes ********/
/* first line: length masks */
	strcpy(s,s1);		/* it was pre-readed */
	strcat(s," ");
	n=0;	st=s;	tie=tiv=toe=tov=-1;
	while ((*st!='\0')&&((tie==-1)||(tiv==-1)||(toe==-1)||(tov==-1)))
	{
		while (iswspace(*st))
			/* strdel1(st);*/ st++;
		sc=strwsp(st);
		if (n==tin)
		{
			tie=st-s;
			tiv=sc-s;
		}
		if (n==tout)
		{
			toe=st-s;
			tov=sc-s;
		}
		st=sc;
		n++;
	}
	/* helyet foglalunk a ko'dok ta'bla'zata'nak */
	*incod=(byte**)malloc(MaxCodeNum*sizeof(byte*));	/* mutatok a kodokra*/
	*outcod=(byte**)malloc(MaxCodeNum*sizeof(byte*));
	if ((incod==NULL)||(outcod==NULL))
		exit(251);
	(*incod)[0]=(byte*)malloc(CodeBlkSize*sizeof(byte));/*itt lesznek a kodok*/
	(*outcod)[0]=(byte*)malloc(CodeBlkSize*sizeof(byte));
	if (((*incod)[0]==NULL)||((*outcod)[0]==NULL))
		exit(251);	/* nincs eleg memory */

/*************** reading the codes - one line for one hun. letter ********/
	resin=resout=CodeBlkSize;
	i=jin=jout=0;
	while (!feof(f))	/* es most a kodokat is beolvassuk */
	{
		if (myfgets(s,MaxLineLen,f)==NULL)	/* read one line */
			break;				/* EOF reached */
		if ((s[0]==0x84)			/* umlaut a, CWIben */
			&& (!nemetkodok))		/* az jelzi a nemetek kezdetet */
			break;
		(*incod)[i]=(*incod)[0]+jin;		/* kov. kod az eddigiek utan */
		strncpy((char*)(*incod)[i],s+tie,tiv-tie);	/* kezdodik, */
		sc=(char*)(*incod)[i]+tiv-tie-1;			/* hossza adott */
		while (iswspace(*sc))				/* .. de a kodvegi space, tab */
			--sc;							/* nem kell */
		if (*sc=='#')				/* kodvegi # a kotelezo space jele */
			*sc=' ';
		*(sc+1)='\0';
		jin=(char*)sc+2-(char*)((*incod)[0]);				/* beallitjuk az eddigiek veget*/
		if (jin>=resin-MaxCodeLen)			/* kell meg memoria */
		{
			int	j;
			byte *tmp;
			tmp=(*incod)[0];
			(*incod)[0]=(byte*)realloc((char*)(*incod)[0],resin+=CodeBlkSize);
			for (j=1;j<=i;j++)
				(*incod)[j] += (*incod)[0]-tmp;
		}
		(*outcod)[i]=(*outcod)[0]+jout;		/* ugyanez a kimeneti kodokkal*/
		strncpy((char*)(*outcod)[i],s+toe,tov-toe);
		sc=(char*)(*outcod)[i]+tov-toe-1;
		while (iswspace(*sc))
			--sc;
		if (*sc=='#')				/* kodvegi # a kotelezo space jele */
			*sc=' ';
		*(sc+1)='\0';
		jout=(char*)sc+2-(char*)((*outcod)[0]);
		if (jout>=resout-MaxCodeLen)			/* kell meg memoria */
		{
			int	j;
			byte *tmp;
			tmp=(*outcod)[0];
			(*outcod)[0]=(byte*)realloc((char*)(*outcod)[0],resout+=CodeBlkSize);
			for (j=1;j<=i;j++)
				(*outcod)[j] += (*outcod)[0]-tmp;
		}
		i++;								/* es a kovetkezo... */
	}
	*cod_n=i;
	for (j=1;j<i;j++)
		for (k=0;k<j;k++)
			if (strcmp((char*)(*incod)[k],(char*)(*incod)[j])==0)
			{
				fprintf(stderr," Error !   In table %s ",tabfnev);
				fprintf(stderr,"two different characters\n");
				fprintf(stderr,"use the same code (%s) ",(*incod)[k]);
				fprintf(stderr,"(convention `%s\',lines %d and %d).\n",
					cname[tin],k+1,j+1);
				exit(-1);
			}
	return 0;
}

LoadAllCodes(char *ut, char *ut2, char *tabfnev,
						byte ***incod,int *codsn,int *cod_n)
{
	FILE *f;
	nev utvonal;
	byte s[2*MaxLineLen],s1[MaxLineLen],*st,*sc;
	int i,j,k,n,c,resin;
	int codstp[MaxCodeSetNum+1];	/* code start point (ofs in the line) */
	int aei_n=0;

	strcpy(utvonal,ut);
	if ((f=fopen(tabfnev,"r"))==NULL)
		if ((f=fopen(strcat(utvonal,tabfnev),"r"))==NULL)
			{
			strcpy(utvonal,ut2);
			if ((f=fopen(strcat(utvonal,tabfnev),"r"))==NULL)
				{
				fprintf(stderr,"Table file '%s' does not exist\n",tabneve);
				fputs("or environment variable 'codeconv' not set.\n",stderr);
				exit(1);
				}
			}
	if (myfgets(s,MaxLineLen,f)==NULL)
		myerror("Error in the table\n",3);
	if (myfgets(s1,MaxLineLen,f)==NULL)
		myerror("Error in the table\n",3);
	while (iswspace(s1[0]))		/* names continuing in the next line */
	{
		strcat(s,s1);
		if (myfgets(s1,MaxLineLen,f)==NULL)
			myerror("Error in the table\n",3);
	}
/* Now we have the names, but we need the abbrevs */
	strcpy(s,s1);
	if (myfgets(s1,MaxLineLen,f)==NULL)
		myerror("Error in the table\n",3);
	while (iswspace(s1[0]))		/* abbrevs continuing in the next line */
	{
		strcat(s,s1);
		if (myfgets(s1,MaxLineLen,f)==NULL)
			myerror("Error in the table\n",3);
	}
	strcat(s," ");			/* to be sure */
	st=s;
	for (i=1;*st!='\0';i++)
	{
		if ((st[0]=='a')&&(st[1]=='e')&&(st[2]=='i')&&iswspace(st[3]))
			aei_n=i-1;
		while (!iswspace(*st))
			st++;
		while ((iswspace(*st))&&(*st!='\0'))
			st++;
	}	/* megneztuk, hany db kodolas van */
	*codsn=i-1;
	if (futinfkiir)
		fprintf(stderr,"%d code systems read from the table.\n",*codsn);
/******************** Codes following ******************/
/****** first the length masks */
	strcpy(s,s1);		/* it was pre-readed */
	strcat(s," ");
	n=0;	st=s;
	while (*st!='\0')
	{
		while (iswspace(*st))
			/* strdel1(st);*/ st++;
		sc=(byte*)strwsp((char*)st);
		codstp[n++]=st-s;
/*		fprintf(stderr,"codstp[%d] = %d\n",n-1,st-s); */
		st=sc+1;
	}
	codstp[n]=strlen((char*)s);
/*	fprintf(stderr,"codstp[%d] = %d\n",n,strlen((char*)s));*/
	/* helyet foglalunk a ko'dok ta'bla'zata'nak */
	*incod=(byte**)malloc(MaxCodeNum*sizeof(byte*));
	/* mutato'k a kodokra*/
	if (incod==NULL)
		exit(3);	/* nincs eleg memoria */
	(*incod)[0]=(byte*)malloc(CodeBlkSize*sizeof(byte));
	/*itt lesznek a kodok*/
	if ((*incod)[0]==NULL)
		exit(3);	/* nincs eleg memoria */
	resin=CodeBlkSize;		i=0;	j=0;	*cod_n=0;
	while (!feof(f))		/* es most a kodokat is beolvassuk */
	{
		if (myfgets(s,MaxLineLen,f)==NULL)
			break;
		if (strlen((char*)s) < codstp[*codsn-1])	/* tul rovid sor */
			break;
		if ((s[0]==0x84)			/* umlaut a, CWIben */
			&& (!nemetkodok))		/* az jelzi a nemetek kezdetet */
			break;
/*		fprintf(stderr,"length(s)=%2d\n",strlen((char*)s));*/
		(*cod_n)++;
/* kov. kod az eddigiek utan kezdodik, hossza adott */
		for (k=0;k<*codsn;k++)
		{
			(*incod)[i]=(*incod)[0]+j;
			strncpy((char*)(*incod)[i],(char*)s+codstp[k],codstp[k+1]-codstp[k]-1);
			sc=(*incod)[i]+codstp[k+1]-codstp[k]-1;
			while (iswspace(*(sc-1)))			/* a kodvegi space, tab */
				--sc;						/* nem kell */
			if (*(sc-1)=='#')			/* kodvegi # a kotelezo space jele */
				*(sc-1)=' ';
			*sc='\0';
			j=sc+1-(*incod)[0];				/* beallitjuk az eddigiek veget*/
			if (j>=resin-MaxCodeLen)			/* kell meg memoria */
			{
				int	k;
				byte *tmp;
				tmp=(*incod)[0];
				resin+=CodeBlkSize;
				(*incod)[0]=(byte*)realloc((char*)(*incod)[0],resin);
				for (k=1;k<=i;k++)
					(*incod)[k] += (*incod)[0]-tmp;
			}
			i++;							/* es a kovetkezo... */
		}
	}
	for (j=1;j<i;j++)
		for (k=0;k<j;k++)
			if ((strcmp((char*)(*incod)[j],(char*)(*incod)[k])==0)
				&&((j-k)%*codsn==0)&&(k%*codsn!=aei_n))
			{
				fprintf(stderr,"Warning!  In table %s ",tabfnev);
				fprintf(stderr,"two different characters\n");
				fprintf(stderr,"use the same code (%s) ",(*incod)[k]);
				fprintf(stderr,
					"(convention `%s\', lines %d and %d).\n",
					cname[k%*codsn],k/(*codsn)+1,j/(*codsn)+1);
/*				exit(-1);*/
			}
/*	fputs("Allcodes.\n",stderr);*/
	return 0;
}

LoadNames(char *ut, char *ut2, char *tabfnev, char **cname, char **cabbr, int *n)
{
	FILE *f;
	nev utvonal;
	byte s[2*MaxLineLen],s1[MaxLineLen],*st,*sc,c;

	strcpy(utvonal,ut);
	if ((f=fopen(tabfnev,"r"))==NULL)
		if ((f=fopen(strcat(utvonal,tabfnev),"r"))==NULL)
			{
			strcpy(utvonal,ut2);
			if ((f=fopen(strcat(utvonal,tabfnev),"r"))==NULL)
				{
				fprintf(stderr,"Table file '%s' does not exist\n",tabneve);
				fputs("or environment variable 'codeconv' not set.\n",stderr);
				exit(1);
				}
			}
	if (myfgets(s,MaxLineLen,f)==NULL)
		myerror("Error in the table\n",3);
	if (myfgets(s1,MaxLineLen,f)==NULL)
		myerror("Error in the table\n",3);
	while (iswspace(s1[0]))		/* names continuing in the next line */
	{
		strcat(s,s1);
		if (myfgets(s1,MaxLineLen,f)==NULL)
			myerror("Error in the table\n",3);
	}			/* names O.K. */
	strcat(s," ");
	st=s;			*n=0;
	do{
		while (iswspace(*st))
			st++;
		if (*st=='\0')
			break;
		sc=strwsp(st);
		strncpy(cname[*n],st,sc-st);
		cname[*n][sc-st]='\0';
		cname[*n+1]=cname[*n]+(sc-st)+1;	/* kov. nev kozvetlenul utana jon */
		st=strwsp(st)+1;
		(*n)++;
	}while (1);	/* keszen vannak a nevek*/
	strcpy(s,s1);
	if (myfgets(s1,MaxLineLen,f)==NULL)
		myerror("Error in the table\n",3);
	while (iswspace(s1[0]))		/* abbrevs continuing in the next line */
	{
		strcat(s,s1);
		if (myfgets(s1,MaxLineLen,f)==NULL)
			myerror("Error in the table\n",3);
	}		/* Roviditesek beolvasva */
	strcat(s," ");
	st=s;			*n=0;
	do{
		while (iswspace(*st))
			st++;
		if (*st=='\0')
			break;
		sc=strwsp(st);
		strncpy(cabbr[*n],st,sc-st);
		cabbr[*n][sc-st]='\0';
		cabbr[*n+1]=cabbr[*n]+(sc-st)+1;	/* kov.rov. kozvetlenul utana jon */
		st=strwsp(st)+1;
		(*n)++;
	}while (1);	/* keszen vannak a roviditesek*/
	fclose(f);
	return 0;
}
