#include "w95lfn.h"

int w95open(const char *path, int access)
{
#ifdef __MSDOS__
	union REGS regs;

	regs.x.ax = 0x716C;	/* w95 function: long-name open */
	regs.x.dx = 1;	/* open */
	regs.x.bx = 2;
	if (access | O_RDONLY)
		regs.x.bx = 0;
	if (access | O_WRONLY)
		regs.x.bx = 1;
	if (access | O_RDWR)
		regs.x.bx = 2;
/*	else {
		errno = EINVACC;
		return -1;
	}*/

	if (access & O_CREAT)
		regs.x.dx |= 0x10;	/* create */
	if (access & O_TRUNC)
		regs.x.dx |= 0x02;	/* truncate */

	regs.x.cx = 0;		/* try */
	regs.x.si = FP_OFF(path);

	intdos(&regs,&regs);

	if (regs.x.ax == 0x7100)	/* not supported */
		return -2;
	if (regs.x.cflag) {
		errno = ENOENT;
		return -1;
	}

	return regs.x.ax;
#else
	return -2;
#endif
}

int w95move(const char *path, const char *newpath)
{
#ifdef __MSDOS__
	union REGS regs;

	regs.x.ax = 0x7156;	/* w95 function: long-name move/rename */
	regs.x.dx = FP_OFF(path);
	regs.x.di = FP_OFF(newpath);

	intdos(&regs,&regs);

	if (regs.x.ax == 0x7100)	/* not supported */
		return -2;
	if (regs.x.cflag) {
		errno = ENOENT;
		return -1;
	}

	return 0;
#else
	return -2;
#endif
}

int w95delete(const char *path)
{
#ifdef __MSDOS__
	union REGS regs;

	regs.x.ax = 0x7141;	/* w95 function: long-name delete */
	regs.x.dx = FP_OFF(path);
	regs.x.si = 0;
	regs.x.cx = 0;

	intdos(&regs,&regs);

	if (regs.x.ax == 0x7100)	/* not supported */
		return -2;
	if (regs.x.cflag) {
		errno = ENOENT;
		return -1;
	}

	return 0;
#else
	return -2;
#endif
}

